/***************************************************************************
                          ingredients.h  -  Header for console
                             -------------------
    begin                : Sat Sep 22 2001
    copyright            : (C) 2001 by Josiah Zayner
    email                : ajz023@motorola.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _INGREDIENTS_H
#define _INGREDIENTS_H

#ifndef _BSD_SOURCE
#define _BSD_SOURCE
#endif

#ifndef __FAVOR_BSD
#define __FAVOR_BSD
#endif

#ifndef __USE_BSD
#define __USE_BSD
#endif

#ifndef __USE_BSD_SOURCE
#define __USE_BSD_SOURCE
#endif

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <netdb.h>
#include <time.h>
/* #include <pcap.h>  */
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/nameser.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <arpa/inet.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>


/* to recv all ethernet packets on device */
#define ETH_P_ALL   0x0003

/* socket level define for IP */
#define SOL_IP      0


/* prefixed to tcp and udp header for checksum so we get protection from misrouted segments */
struct nmrhdr{

  struct in_addr saddr;
  struct in_addr daddr;
  u_char none;
  u_char protocol;
  u_short length;

};


void *clalloc(int bytes);
struct in_addr wherefromto(char *herefrom);


u_short in_cksum(u_short *addr, int len); /* to calculate internet checksum */

/* send out our creations! */
int cast_spell(char *envelope, int env_size, u_int8_t deport, struct in_addr src);

/* to intialize our IP header */
void ip_sorcery(struct ip *ip_sorc,
                struct in_addr source,
                struct in_addr dest,
                int proto,
                unsigned int hl,
                unsigned int ver,
                u_char tos,
                u_short len,
                u_short id,
                u_char ttl,
                int off
               );

/* build our packets */
int tcp_sorcery(struct tcphdr *tcp_magic, struct ip *ip_magic, char *pack, char *datap, int dps);
int udp_sorcery(struct udphdr *udpp, struct ip *ip_magic, char *pack, char *datap, int dps);
int icmp_sorcery(struct icmp *icmp_magic, struct ip *ip_magic, char *pack, char *datap, int dps);

/* print an error */
void prterr(char *message);

#endif /* _INGREDIENTS_H */
