/***************************************************************************
                          magic.h  -  For our Magic Spells
                             -------------------
    begin                : Wed Jul 25 2001
    copyright            : (C) 2001 by Josiah Zayner
    email                : ajz023@motorola.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _MAGIC_H
#define _MAGIC_H

#ifndef _BSD_SOURCE
#define _BSD_SOURCE
#endif

#ifndef __FAVOR_BSD
#define __FAVOR_BSD
#endif

#ifndef __USE_BSD
#define __USE_BSD
#endif

#ifndef __USE_BSD_SOURCE
#define __USE_BSD_SOURCE
#endif

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <netdb.h>
#include <time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/nameser.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <gtk/gtk.h>


#define TCPIP        sizeof(struct ip) + sizeof(struct tcphdr)
#define TCP          sizeof(struct tcphdr)
#define SOL_IP       0

/* prefixed to tcp and udp header for checksum so we get protection from misrouted segments */
struct nmrhdr{

  struct in_addr saddr;
  struct in_addr daddr;
  u_int8_t none;
  u_int8_t protocol;
  u_int16_t length;

};

struct packmack{

  u_char d_port;
  int packsz;

};

GtkWidget *fixed_pos;


/*
   it's all gtk_signal_connect()'s fault I tell ya', it allows only one argument
   and when I tried to make it a struct so I have no globals it would just seg fault
   and core, yeah nice, so instead i got alot of globals and alot of void func(void)
*/
struct packmack *icmp_gather(char *icmp_pack);
struct packmack *udp_gather(char *udp_pack);
struct packmack *tcp_gather(char *tcp_pack, struct in_addr sourcery, struct in_addr destined);
void gather_info(char *envelope, int proto, int pasize);

void ip_cauldron(void);
void tcp_spell(void);
void udp_spell(void);
void icmp_spell(void);

void clear_tcp(void);
void clear_udp(void);
void clear_icmp(void);
void clear_dns(void);

void ip_defaults(GtkWidget *oldbutton);
void tcp_defaults(void);
void udp_defaults(void);
void icmp_defaults(void);
void send_packet(GtkWidget *oldbutton);
void *clalloc(int bytes);
void prterr(char *message);
int packet_send(void);

/* for the ICMP type combo box */
int geticmptypebyname(const char *type_name);

/* for the ICMP sub combo box */
int geticmpsubbyname(const char *sub_name);


/* from spells.c */
struct in_addr wherefromto(char *herefrom);
u_short in_cksum(u_short *addr, int len);


/* for making and displaying widgets! */

/* for combo box */
GtkWidget *make_combo(GtkWidget *box,
                      int obj_len,
                      int obj_hi,
                      short int pos_len,
                      short int pos_hi
                     );

/* for dem der labels */
GtkWidget *make_label(GtkWidget *lbl,
                      char *text,
                      short int pos_len,
                      short int pos_hi
                     );

/* yes you guessed it for buttons */
GtkWidget *make_button(GtkWidget *button,
                       char *text,
                       int obj_len,
                       int obj_hi,
                       short int pos_len,
                       short int pos_hi,
                       GtkWidget *fixed
                      );

/* for text boxes */
GtkWidget *make_text(GtkWidget *text,
                     int obj_len,
                     int obj_hi,
                     short int pos_len,
                     short int pos_hi
                    );

/* for check boxes */
GtkWidget *make_check(GtkWidget *check,
                      const char *label,
                      short int pos_len,
                      short int pos_hi
                     );

GtkWidget *make_te(GtkWidget *text,
                   int obj_len,
                   int obj_hi,
                   short int pos_len,
                   short int pos_hi
                  );

#endif /* _MAGIC_H */

